/* File.c generated by valac 0.56.15, the Vala compiler
 * generated from File.vala, do not modify */

/*-
 * Copyright (c) 2017 elementary LLC. (https://elementary.io),
 *               2013 Julien Spautz <spautz.julien@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 3
 * as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranties of
 * MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
 * PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Julien Spautz <spautz.julien@gmail.com>, Andrei-Costin Zisu <matzipan@gmail.com>
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define SCRATCH_FOLDER_MANAGER_TYPE_FILE (scratch_folder_manager_file_get_type ())
#define SCRATCH_FOLDER_MANAGER_FILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SCRATCH_FOLDER_MANAGER_TYPE_FILE, ScratchFolderManagerFile))
#define SCRATCH_FOLDER_MANAGER_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SCRATCH_FOLDER_MANAGER_TYPE_FILE, ScratchFolderManagerFileClass))
#define SCRATCH_FOLDER_MANAGER_IS_FILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SCRATCH_FOLDER_MANAGER_TYPE_FILE))
#define SCRATCH_FOLDER_MANAGER_IS_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SCRATCH_FOLDER_MANAGER_TYPE_FILE))
#define SCRATCH_FOLDER_MANAGER_FILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SCRATCH_FOLDER_MANAGER_TYPE_FILE, ScratchFolderManagerFileClass))

typedef struct _ScratchFolderManagerFile ScratchFolderManagerFile;
typedef struct _ScratchFolderManagerFileClass ScratchFolderManagerFileClass;
typedef struct _ScratchFolderManagerFilePrivate ScratchFolderManagerFilePrivate;
enum  {
	SCRATCH_FOLDER_MANAGER_FILE_0_PROPERTY,
	SCRATCH_FOLDER_MANAGER_FILE_FILE_PROPERTY,
	SCRATCH_FOLDER_MANAGER_FILE_PATH_PROPERTY,
	SCRATCH_FOLDER_MANAGER_FILE_NAME_PROPERTY,
	SCRATCH_FOLDER_MANAGER_FILE_ICON_PROPERTY,
	SCRATCH_FOLDER_MANAGER_FILE_EXISTS_PROPERTY,
	SCRATCH_FOLDER_MANAGER_FILE_IS_TEMPORARY_PROPERTY,
	SCRATCH_FOLDER_MANAGER_FILE_IS_VALID_TEXTFILE_PROPERTY,
	SCRATCH_FOLDER_MANAGER_FILE_IS_EXECUTABLE_PROPERTY,
	SCRATCH_FOLDER_MANAGER_FILE_CHILDREN_PROPERTY,
	SCRATCH_FOLDER_MANAGER_FILE_NUM_PROPERTIES
};
static GParamSpec* scratch_folder_manager_file_properties[SCRATCH_FOLDER_MANAGER_FILE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _ScratchFolderManagerFile {
	GObject parent_instance;
	ScratchFolderManagerFilePrivate * priv;
};

struct _ScratchFolderManagerFileClass {
	GObjectClass parent_class;
};

struct _ScratchFolderManagerFilePrivate {
	GFile* _file;
	GFileInfo* info;
	gchar* _name;
	GIcon* _icon;
	gboolean children_valid;
	GeeArrayList* _children;
};

static gint ScratchFolderManagerFile_private_offset;
static gpointer scratch_folder_manager_file_parent_class = NULL;

VALA_EXTERN GType scratch_folder_manager_file_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ScratchFolderManagerFile, g_object_unref)
VALA_EXTERN ScratchFolderManagerFile* scratch_folder_manager_file_new (const gchar* path);
VALA_EXTERN ScratchFolderManagerFile* scratch_folder_manager_file_construct (GType object_type,
                                                                 const gchar* path);
VALA_EXTERN gboolean scratch_folder_manager_file_is_valid_directory (ScratchFolderManagerFile* self,
                                                         gboolean allow_hidden);
VALA_EXTERN const gchar* scratch_folder_manager_file_get_name (ScratchFolderManagerFile* self);
static gboolean scratch_folder_manager_file_get_boolean_file_attribute (ScratchFolderManagerFile* self,
                                                                 const gchar* attribute,
                                                                 GError** error);
VALA_EXTERN GFile* scratch_folder_manager_file_get_file (ScratchFolderManagerFile* self);
static void scratch_folder_manager_file_load_file_for_path (ScratchFolderManagerFile* self,
                                                     const gchar* path);
static void scratch_folder_manager_file_set_file (ScratchFolderManagerFile* self,
                                           GFile* value);
VALA_EXTERN void scratch_folder_manager_file_rename (ScratchFolderManagerFile* self,
                                         const gchar* name);
VALA_EXTERN gboolean scratch_folder_manager_file_get_exists (ScratchFolderManagerFile* self);
VALA_EXTERN void scratch_folder_manager_file_trash (ScratchFolderManagerFile* self);
VALA_EXTERN gint scratch_folder_manager_file_compare (ScratchFolderManagerFile* a,
                                          ScratchFolderManagerFile* b);
VALA_EXTERN gboolean scratch_folder_manager_file_get_is_valid_textfile (ScratchFolderManagerFile* self);
VALA_EXTERN gchar* scratch_folder_manager_file_get_path (ScratchFolderManagerFile* self);
VALA_EXTERN void scratch_folder_manager_file_invalidate_cache (ScratchFolderManagerFile* self);
VALA_EXTERN void scratch_folder_manager_file_set_path (ScratchFolderManagerFile* self,
                                           const gchar* value);
VALA_EXTERN GIcon* scratch_folder_manager_file_get_icon (ScratchFolderManagerFile* self);
VALA_EXTERN gboolean scratch_folder_manager_file_get_is_temporary (ScratchFolderManagerFile* self);
VALA_EXTERN gboolean scratch_utils_check_if_valid_text_file (const gchar* path,
                                                 GFileInfo* info);
VALA_EXTERN gboolean scratch_folder_manager_file_get_is_executable (ScratchFolderManagerFile* self);
VALA_EXTERN GeeCollection* scratch_folder_manager_file_get_children (ScratchFolderManagerFile* self);
static void scratch_folder_manager_file_finalize (GObject * obj);
static GType scratch_folder_manager_file_get_type_once (void);
static void _vala_scratch_folder_manager_file_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_scratch_folder_manager_file_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);

static inline gpointer
scratch_folder_manager_file_get_instance_private (ScratchFolderManagerFile* self)
{
	return G_STRUCT_MEMBER_P (self, ScratchFolderManagerFile_private_offset);
}

ScratchFolderManagerFile*
scratch_folder_manager_file_construct (GType object_type,
                                       const gchar* path)
{
	ScratchFolderManagerFile * self = NULL;
#line 30 "../src/FolderManager/File.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 31 "../src/FolderManager/File.vala"
	self = (ScratchFolderManagerFile*) g_object_new (object_type, "path", path, NULL);
#line 30 "../src/FolderManager/File.vala"
	return self;
#line 160 "File.c"
}

ScratchFolderManagerFile*
scratch_folder_manager_file_new (const gchar* path)
{
#line 30 "../src/FolderManager/File.vala"
	return scratch_folder_manager_file_construct (SCRATCH_FOLDER_MANAGER_TYPE_FILE, path);
#line 168 "File.c"
}

gboolean
scratch_folder_manager_file_is_valid_directory (ScratchFolderManagerFile* self,
                                                gboolean allow_hidden)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GFileInfo* _tmp5_;
	gboolean result;
#line 82 "../src/FolderManager/File.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 83 "../src/FolderManager/File.vala"
	if (!allow_hidden) {
#line 183 "File.c"
		const gchar* _tmp2_;
		const gchar* _tmp3_;
#line 83 "../src/FolderManager/File.vala"
		_tmp2_ = scratch_folder_manager_file_get_name (self);
#line 83 "../src/FolderManager/File.vala"
		_tmp3_ = _tmp2_;
#line 83 "../src/FolderManager/File.vala"
		_tmp1_ = g_str_has_prefix (_tmp3_, ".");
#line 192 "File.c"
	} else {
#line 83 "../src/FolderManager/File.vala"
		_tmp1_ = FALSE;
#line 196 "File.c"
	}
#line 83 "../src/FolderManager/File.vala"
	if (_tmp1_) {
#line 83 "../src/FolderManager/File.vala"
		_tmp0_ = TRUE;
#line 202 "File.c"
	} else {
		GFileInfo* _tmp4_;
#line 84 "../src/FolderManager/File.vala"
		_tmp4_ = self->priv->info;
#line 84 "../src/FolderManager/File.vala"
		_tmp0_ = g_file_info_get_is_backup (_tmp4_);
#line 209 "File.c"
	}
#line 83 "../src/FolderManager/File.vala"
	if (_tmp0_) {
#line 86 "../src/FolderManager/File.vala"
		result = FALSE;
#line 86 "../src/FolderManager/File.vala"
		return result;
#line 217 "File.c"
	}
#line 89 "../src/FolderManager/File.vala"
	_tmp5_ = self->priv->info;
#line 89 "../src/FolderManager/File.vala"
	if (g_file_info_get_file_type (_tmp5_) == G_FILE_TYPE_DIRECTORY) {
#line 90 "../src/FolderManager/File.vala"
		result = TRUE;
#line 90 "../src/FolderManager/File.vala"
		return result;
#line 227 "File.c"
	}
#line 93 "../src/FolderManager/File.vala"
	result = FALSE;
#line 93 "../src/FolderManager/File.vala"
	return result;
#line 233 "File.c"
}

static gboolean
scratch_folder_manager_file_get_boolean_file_attribute (ScratchFolderManagerFile* self,
                                                        const gchar* attribute,
                                                        GError** error)
{
	GFileInfo* info = NULL;
	GFile* _tmp0_;
	GFileInfo* _tmp1_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 155 "../src/FolderManager/File.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 155 "../src/FolderManager/File.vala"
	g_return_val_if_fail (attribute != NULL, FALSE);
#line 156 "../src/FolderManager/File.vala"
	_tmp0_ = self->priv->_file;
#line 156 "../src/FolderManager/File.vala"
	_tmp1_ = g_file_query_info (_tmp0_, attribute, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 156 "../src/FolderManager/File.vala"
	info = _tmp1_;
#line 156 "../src/FolderManager/File.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 258 "File.c"
		gboolean _tmp2_ = FALSE;
#line 156 "../src/FolderManager/File.vala"
		g_propagate_error (error, _inner_error0_);
#line 156 "../src/FolderManager/File.vala"
		return _tmp2_;
#line 264 "File.c"
	}
#line 158 "../src/FolderManager/File.vala"
	result = g_file_info_get_attribute_boolean (info, attribute);
#line 158 "../src/FolderManager/File.vala"
	_g_object_unref0 (info);
#line 158 "../src/FolderManager/File.vala"
	return result;
#line 272 "File.c"
}

static void
scratch_folder_manager_file_load_file_for_path (ScratchFolderManagerFile* self,
                                                const gchar* path)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 161 "../src/FolderManager/File.vala"
	g_return_if_fail (self != NULL);
#line 161 "../src/FolderManager/File.vala"
	g_return_if_fail (path != NULL);
#line 162 "../src/FolderManager/File.vala"
	_tmp0_ = g_file_new_for_path (path);
#line 162 "../src/FolderManager/File.vala"
	_tmp1_ = _tmp0_;
#line 162 "../src/FolderManager/File.vala"
	scratch_folder_manager_file_set_file (self, _tmp1_);
#line 162 "../src/FolderManager/File.vala"
	_g_object_unref0 (_tmp1_);
#line 164 "../src/FolderManager/File.vala"
	_tmp2_ = g_file_info_new ();
#line 164 "../src/FolderManager/File.vala"
	_g_object_unref0 (self->priv->info);
#line 164 "../src/FolderManager/File.vala"
	self->priv->info = _tmp2_;
#line 301 "File.c"
	{
		gchar* query_string = NULL;
		gchar* _tmp3_;
		GFileInfo* _tmp4_ = NULL;
		GFile* _tmp5_;
		GFileInfo* _tmp6_;
		GFileInfo* _tmp7_;
#line 166 "../src/FolderManager/File.vala"
		_tmp3_ = g_strdup (G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE "," G_FILE_ATTRIBUTE_STANDARD_IS_BACKUP "," G_FILE_ATTRIBUTE_STANDARD_IS_HIDDEN "," G_FILE_ATTRIBUTE_STANDARD_DISPLAY_NAME "," G_FILE_ATTRIBUTE_STANDARD_TYPE);
#line 166 "../src/FolderManager/File.vala"
		query_string = _tmp3_;
#line 172 "../src/FolderManager/File.vala"
		_tmp5_ = self->priv->_file;
#line 172 "../src/FolderManager/File.vala"
		_tmp6_ = g_file_query_info (_tmp5_, query_string, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 172 "../src/FolderManager/File.vala"
		_tmp4_ = _tmp6_;
#line 172 "../src/FolderManager/File.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 172 "../src/FolderManager/File.vala"
			_g_free0 (query_string);
#line 323 "File.c"
			goto __catch0_g_error;
		}
#line 172 "../src/FolderManager/File.vala"
		_tmp7_ = _tmp4_;
#line 172 "../src/FolderManager/File.vala"
		_tmp4_ = NULL;
#line 172 "../src/FolderManager/File.vala"
		_g_object_unref0 (self->priv->info);
#line 172 "../src/FolderManager/File.vala"
		self->priv->info = _tmp7_;
#line 165 "../src/FolderManager/File.vala"
		_g_object_unref0 (_tmp4_);
#line 165 "../src/FolderManager/File.vala"
		_g_free0 (query_string);
#line 338 "File.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 165 "../src/FolderManager/File.vala"
		_error_ = _inner_error0_;
#line 165 "../src/FolderManager/File.vala"
		_inner_error0_ = NULL;
#line 174 "../src/FolderManager/File.vala"
		_g_object_unref0 (self->priv->info);
#line 174 "../src/FolderManager/File.vala"
		self->priv->info = NULL;
#line 175 "../src/FolderManager/File.vala"
		_tmp8_ = _error_;
#line 175 "../src/FolderManager/File.vala"
		_tmp9_ = _tmp8_->message;
#line 175 "../src/FolderManager/File.vala"
		g_warning ("File.vala:175: %s", _tmp9_);
#line 165 "../src/FolderManager/File.vala"
		_g_error_free0 (_error_);
#line 362 "File.c"
	}
	__finally0:
#line 165 "../src/FolderManager/File.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 165 "../src/FolderManager/File.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 165 "../src/FolderManager/File.vala"
		g_clear_error (&_inner_error0_);
#line 165 "../src/FolderManager/File.vala"
		return;
#line 373 "File.c"
	}
}

void
scratch_folder_manager_file_rename (ScratchFolderManagerFile* self,
                                    const gchar* name)
{
	GError* _inner_error0_ = NULL;
#line 179 "../src/FolderManager/File.vala"
	g_return_if_fail (self != NULL);
#line 179 "../src/FolderManager/File.vala"
	g_return_if_fail (name != NULL);
#line 386 "File.c"
	{
		gboolean _tmp0_;
		gboolean _tmp1_;
#line 181 "../src/FolderManager/File.vala"
		_tmp0_ = scratch_folder_manager_file_get_exists (self);
#line 181 "../src/FolderManager/File.vala"
		_tmp1_ = _tmp0_;
#line 181 "../src/FolderManager/File.vala"
		if (_tmp1_) {
#line 396 "File.c"
			GFile* _tmp2_;
			GFile* _tmp3_;
			GFile* _tmp4_;
#line 182 "../src/FolderManager/File.vala"
			_tmp2_ = self->priv->_file;
#line 182 "../src/FolderManager/File.vala"
			_tmp3_ = g_file_set_display_name (_tmp2_, name, NULL, &_inner_error0_);
#line 182 "../src/FolderManager/File.vala"
			_tmp4_ = _tmp3_;
#line 182 "../src/FolderManager/File.vala"
			_g_object_unref0 (_tmp4_);
#line 182 "../src/FolderManager/File.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 410 "File.c"
				goto __catch0_g_error;
			}
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 180 "../src/FolderManager/File.vala"
		_error_ = _inner_error0_;
#line 180 "../src/FolderManager/File.vala"
		_inner_error0_ = NULL;
#line 185 "../src/FolderManager/File.vala"
		_tmp5_ = _error_;
#line 185 "../src/FolderManager/File.vala"
		_tmp6_ = _tmp5_->message;
#line 185 "../src/FolderManager/File.vala"
		g_warning ("File.vala:185: %s", _tmp6_);
#line 180 "../src/FolderManager/File.vala"
		_g_error_free0 (_error_);
#line 433 "File.c"
	}
	__finally0:
#line 180 "../src/FolderManager/File.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 180 "../src/FolderManager/File.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 180 "../src/FolderManager/File.vala"
		g_clear_error (&_inner_error0_);
#line 180 "../src/FolderManager/File.vala"
		return;
#line 444 "File.c"
	}
}

void
scratch_folder_manager_file_trash (ScratchFolderManagerFile* self)
{
	GError* _inner_error0_ = NULL;
#line 189 "../src/FolderManager/File.vala"
	g_return_if_fail (self != NULL);
#line 454 "File.c"
	{
		GFile* _tmp0_;
#line 191 "../src/FolderManager/File.vala"
		_tmp0_ = self->priv->_file;
#line 191 "../src/FolderManager/File.vala"
		g_file_trash (_tmp0_, NULL, &_inner_error0_);
#line 191 "../src/FolderManager/File.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 463 "File.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 190 "../src/FolderManager/File.vala"
		_error_ = _inner_error0_;
#line 190 "../src/FolderManager/File.vala"
		_inner_error0_ = NULL;
#line 193 "../src/FolderManager/File.vala"
		_tmp1_ = _error_;
#line 193 "../src/FolderManager/File.vala"
		_tmp2_ = _tmp1_->message;
#line 193 "../src/FolderManager/File.vala"
		g_warning ("File.vala:193: %s", _tmp2_);
#line 190 "../src/FolderManager/File.vala"
		_g_error_free0 (_error_);
#line 485 "File.c"
	}
	__finally0:
#line 190 "../src/FolderManager/File.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 190 "../src/FolderManager/File.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 190 "../src/FolderManager/File.vala"
		g_clear_error (&_inner_error0_);
#line 190 "../src/FolderManager/File.vala"
		return;
#line 496 "File.c"
	}
}

gint
scratch_folder_manager_file_compare (ScratchFolderManagerFile* a,
                                     ScratchFolderManagerFile* b)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_;
	gboolean _tmp5_;
	GCompareFunc _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gint _tmp17_;
	gint result;
#line 197 "../src/FolderManager/File.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 197 "../src/FolderManager/File.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 198 "../src/FolderManager/File.vala"
	if (scratch_folder_manager_file_is_valid_directory (a, TRUE)) {
#line 527 "File.c"
		gboolean _tmp1_;
		gboolean _tmp2_;
#line 198 "../src/FolderManager/File.vala"
		_tmp1_ = scratch_folder_manager_file_get_is_valid_textfile (b);
#line 198 "../src/FolderManager/File.vala"
		_tmp2_ = _tmp1_;
#line 198 "../src/FolderManager/File.vala"
		_tmp0_ = _tmp2_;
#line 536 "File.c"
	} else {
#line 198 "../src/FolderManager/File.vala"
		_tmp0_ = FALSE;
#line 540 "File.c"
	}
#line 198 "../src/FolderManager/File.vala"
	if (_tmp0_) {
#line 199 "../src/FolderManager/File.vala"
		result = -1;
#line 199 "../src/FolderManager/File.vala"
		return result;
#line 548 "File.c"
	}
#line 201 "../src/FolderManager/File.vala"
	_tmp4_ = scratch_folder_manager_file_get_is_valid_textfile (a);
#line 201 "../src/FolderManager/File.vala"
	_tmp5_ = _tmp4_;
#line 201 "../src/FolderManager/File.vala"
	if (_tmp5_) {
#line 201 "../src/FolderManager/File.vala"
		_tmp3_ = scratch_folder_manager_file_is_valid_directory (b, TRUE);
#line 558 "File.c"
	} else {
#line 201 "../src/FolderManager/File.vala"
		_tmp3_ = FALSE;
#line 562 "File.c"
	}
#line 201 "../src/FolderManager/File.vala"
	if (_tmp3_) {
#line 202 "../src/FolderManager/File.vala"
		result = 1;
#line 202 "../src/FolderManager/File.vala"
		return result;
#line 570 "File.c"
	}
#line 205 "../src/FolderManager/File.vala"
	_tmp6_ = ((GCompareFunc) g_strcmp0);
#line 205 "../src/FolderManager/File.vala"
	_tmp7_ = scratch_folder_manager_file_get_path (a);
#line 205 "../src/FolderManager/File.vala"
	_tmp8_ = _tmp7_;
#line 205 "../src/FolderManager/File.vala"
	_tmp9_ = _tmp8_;
#line 205 "../src/FolderManager/File.vala"
	_tmp10_ = g_utf8_collate_key_for_filename (_tmp9_, (gssize) -1);
#line 205 "../src/FolderManager/File.vala"
	_tmp11_ = _tmp10_;
#line 205 "../src/FolderManager/File.vala"
	_tmp12_ = scratch_folder_manager_file_get_path (b);
#line 205 "../src/FolderManager/File.vala"
	_tmp13_ = _tmp12_;
#line 205 "../src/FolderManager/File.vala"
	_tmp14_ = _tmp13_;
#line 205 "../src/FolderManager/File.vala"
	_tmp15_ = g_utf8_collate_key_for_filename (_tmp14_, (gssize) -1);
#line 205 "../src/FolderManager/File.vala"
	_tmp16_ = _tmp15_;
#line 205 "../src/FolderManager/File.vala"
	_tmp17_ = _tmp6_ (_tmp11_, _tmp16_);
#line 205 "../src/FolderManager/File.vala"
	_g_free0 (_tmp16_);
#line 205 "../src/FolderManager/File.vala"
	_g_free0 (_tmp14_);
#line 205 "../src/FolderManager/File.vala"
	_g_free0 (_tmp11_);
#line 205 "../src/FolderManager/File.vala"
	_g_free0 (_tmp9_);
#line 205 "../src/FolderManager/File.vala"
	result = _tmp17_;
#line 205 "../src/FolderManager/File.vala"
	return result;
#line 608 "File.c"
}

void
scratch_folder_manager_file_invalidate_cache (ScratchFolderManagerFile* self)
{
#line 209 "../src/FolderManager/File.vala"
	g_return_if_fail (self != NULL);
#line 210 "../src/FolderManager/File.vala"
	self->priv->children_valid = FALSE;
#line 618 "File.c"
}

GFile*
scratch_folder_manager_file_get_file (ScratchFolderManagerFile* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 27 "../src/FolderManager/File.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../src/FolderManager/File.vala"
	_tmp0_ = self->priv->_file;
#line 27 "../src/FolderManager/File.vala"
	result = _tmp0_;
#line 27 "../src/FolderManager/File.vala"
	return result;
#line 634 "File.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 27 "../src/FolderManager/File.vala"
	return self ? g_object_ref (self) : NULL;
#line 642 "File.c"
}

static void
scratch_folder_manager_file_set_file (ScratchFolderManagerFile* self,
                                      GFile* value)
{
	GFile* old_value;
#line 27 "../src/FolderManager/File.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/FolderManager/File.vala"
	old_value = scratch_folder_manager_file_get_file (self);
#line 27 "../src/FolderManager/File.vala"
	if (old_value != value) {
#line 656 "File.c"
		GFile* _tmp0_;
#line 27 "../src/FolderManager/File.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 27 "../src/FolderManager/File.vala"
		_g_object_unref0 (self->priv->_file);
#line 27 "../src/FolderManager/File.vala"
		self->priv->_file = _tmp0_;
#line 27 "../src/FolderManager/File.vala"
		g_object_notify_by_pspec ((GObject *) self, scratch_folder_manager_file_properties[SCRATCH_FOLDER_MANAGER_FILE_FILE_PROPERTY]);
#line 666 "File.c"
	}
}

gchar*
scratch_folder_manager_file_get_path (ScratchFolderManagerFile* self)
{
	gchar* result;
	GFile* _tmp0_;
	gchar* _tmp1_;
#line 36 "../src/FolderManager/File.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "../src/FolderManager/File.vala"
	_tmp0_ = self->priv->_file;
#line 37 "../src/FolderManager/File.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 37 "../src/FolderManager/File.vala"
	result = _tmp1_;
#line 37 "../src/FolderManager/File.vala"
	return result;
#line 686 "File.c"
}

void
scratch_folder_manager_file_set_path (ScratchFolderManagerFile* self,
                                      const gchar* value)
{
#line 39 "../src/FolderManager/File.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/FolderManager/File.vala"
	scratch_folder_manager_file_load_file_for_path (self, value);
#line 39 "../src/FolderManager/File.vala"
	g_object_notify_by_pspec ((GObject *) self, scratch_folder_manager_file_properties[SCRATCH_FOLDER_MANAGER_FILE_PATH_PROPERTY]);
#line 699 "File.c"
}

const gchar*
scratch_folder_manager_file_get_name (ScratchFolderManagerFile* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	GFileInfo* _tmp2_;
	const gchar* _tmp8_;
#line 47 "../src/FolderManager/File.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "../src/FolderManager/File.vala"
	_tmp0_ = self->priv->_name;
#line 48 "../src/FolderManager/File.vala"
	if (_tmp0_ != NULL) {
#line 715 "File.c"
		const gchar* _tmp1_;
#line 49 "../src/FolderManager/File.vala"
		_tmp1_ = self->priv->_name;
#line 49 "../src/FolderManager/File.vala"
		result = _tmp1_;
#line 49 "../src/FolderManager/File.vala"
		return result;
#line 723 "File.c"
	}
#line 52 "../src/FolderManager/File.vala"
	_tmp2_ = self->priv->info;
#line 52 "../src/FolderManager/File.vala"
	if (_tmp2_ == NULL) {
#line 729 "File.c"
		GFile* _tmp3_;
		gchar* _tmp4_;
#line 53 "../src/FolderManager/File.vala"
		_tmp3_ = self->priv->_file;
#line 53 "../src/FolderManager/File.vala"
		_tmp4_ = g_file_get_basename (_tmp3_);
#line 53 "../src/FolderManager/File.vala"
		_g_free0 (self->priv->_name);
#line 53 "../src/FolderManager/File.vala"
		self->priv->_name = _tmp4_;
#line 740 "File.c"
	} else {
		GFileInfo* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
#line 55 "../src/FolderManager/File.vala"
		_tmp5_ = self->priv->info;
#line 55 "../src/FolderManager/File.vala"
		_tmp6_ = g_file_info_get_display_name (_tmp5_);
#line 55 "../src/FolderManager/File.vala"
		_tmp7_ = g_strdup (_tmp6_);
#line 55 "../src/FolderManager/File.vala"
		_g_free0 (self->priv->_name);
#line 55 "../src/FolderManager/File.vala"
		self->priv->_name = _tmp7_;
#line 755 "File.c"
	}
#line 58 "../src/FolderManager/File.vala"
	_tmp8_ = self->priv->_name;
#line 58 "../src/FolderManager/File.vala"
	result = _tmp8_;
#line 58 "../src/FolderManager/File.vala"
	return result;
#line 763 "File.c"
}

GIcon*
scratch_folder_manager_file_get_icon (ScratchFolderManagerFile* self)
{
	GIcon* result;
	GIcon* _tmp0_;
	GFileInfo* _tmp2_;
	const gchar* _tmp3_;
	GIcon* _tmp4_;
	GIcon* _tmp5_;
#line 65 "../src/FolderManager/File.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 66 "../src/FolderManager/File.vala"
	_tmp0_ = self->priv->_icon;
#line 66 "../src/FolderManager/File.vala"
	if (_tmp0_ != NULL) {
#line 781 "File.c"
		GIcon* _tmp1_;
#line 67 "../src/FolderManager/File.vala"
		_tmp1_ = self->priv->_icon;
#line 67 "../src/FolderManager/File.vala"
		result = _tmp1_;
#line 67 "../src/FolderManager/File.vala"
		return result;
#line 789 "File.c"
	}
#line 70 "../src/FolderManager/File.vala"
	_tmp2_ = self->priv->info;
#line 70 "../src/FolderManager/File.vala"
	_tmp3_ = g_file_info_get_content_type (_tmp2_);
#line 70 "../src/FolderManager/File.vala"
	_tmp4_ = g_content_type_get_icon (_tmp3_);
#line 70 "../src/FolderManager/File.vala"
	_g_object_unref0 (self->priv->_icon);
#line 70 "../src/FolderManager/File.vala"
	self->priv->_icon = _tmp4_;
#line 71 "../src/FolderManager/File.vala"
	_tmp5_ = self->priv->_icon;
#line 71 "../src/FolderManager/File.vala"
	result = _tmp5_;
#line 71 "../src/FolderManager/File.vala"
	return result;
#line 807 "File.c"
}

gboolean
scratch_folder_manager_file_get_exists (ScratchFolderManagerFile* self)
{
	gboolean result;
	GFile* _tmp0_;
#line 77 "../src/FolderManager/File.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 77 "../src/FolderManager/File.vala"
	_tmp0_ = self->priv->_file;
#line 77 "../src/FolderManager/File.vala"
	result = g_file_query_exists (_tmp0_, NULL);
#line 77 "../src/FolderManager/File.vala"
	return result;
#line 823 "File.c"
}

gboolean
scratch_folder_manager_file_get_is_temporary (ScratchFolderManagerFile* self)
{
	gboolean result;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
#line 97 "../src/FolderManager/File.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 98 "../src/FolderManager/File.vala"
	_tmp0_ = scratch_folder_manager_file_get_path (self);
#line 98 "../src/FolderManager/File.vala"
	_tmp1_ = _tmp0_;
#line 98 "../src/FolderManager/File.vala"
	_tmp2_ = _tmp1_;
#line 98 "../src/FolderManager/File.vala"
	_tmp3_ = g_str_has_suffix (_tmp2_, "~");
#line 98 "../src/FolderManager/File.vala"
	_g_free0 (_tmp2_);
#line 98 "../src/FolderManager/File.vala"
	result = _tmp3_;
#line 98 "../src/FolderManager/File.vala"
	return result;
#line 850 "File.c"
}

gboolean
scratch_folder_manager_file_get_is_valid_textfile (ScratchFolderManagerFile* self)
{
	gboolean result;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GFileInfo* _tmp3_;
	gboolean _tmp4_;
#line 104 "../src/FolderManager/File.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 105 "../src/FolderManager/File.vala"
	_tmp0_ = scratch_folder_manager_file_get_path (self);
#line 105 "../src/FolderManager/File.vala"
	_tmp1_ = _tmp0_;
#line 105 "../src/FolderManager/File.vala"
	_tmp2_ = _tmp1_;
#line 105 "../src/FolderManager/File.vala"
	_tmp3_ = self->priv->info;
#line 105 "../src/FolderManager/File.vala"
	_tmp4_ = scratch_utils_check_if_valid_text_file (_tmp2_, _tmp3_);
#line 105 "../src/FolderManager/File.vala"
	_g_free0 (_tmp2_);
#line 105 "../src/FolderManager/File.vala"
	result = _tmp4_;
#line 105 "../src/FolderManager/File.vala"
	return result;
#line 880 "File.c"
}

gboolean
scratch_folder_manager_file_get_is_executable (ScratchFolderManagerFile* self)
{
	gboolean result;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 111 "../src/FolderManager/File.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 891 "File.c"
	{
		gboolean _tmp0_ = FALSE;
#line 113 "../src/FolderManager/File.vala"
		_tmp0_ = scratch_folder_manager_file_get_boolean_file_attribute (self, G_FILE_ATTRIBUTE_ACCESS_CAN_EXECUTE, &_inner_error0_);
#line 113 "../src/FolderManager/File.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 898 "File.c"
			goto __catch0_g_error;
		}
#line 113 "../src/FolderManager/File.vala"
		result = _tmp0_;
#line 113 "../src/FolderManager/File.vala"
		return result;
#line 905 "File.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 112 "../src/FolderManager/File.vala"
		g_clear_error (&_inner_error0_);
#line 115 "../src/FolderManager/File.vala"
		result = FALSE;
#line 115 "../src/FolderManager/File.vala"
		return result;
#line 916 "File.c"
	}
	__finally0:
#line 112 "../src/FolderManager/File.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 112 "../src/FolderManager/File.vala"
	g_clear_error (&_inner_error0_);
#line 112 "../src/FolderManager/File.vala"
	return _tmp1_;
#line 925 "File.c"
}

GeeCollection*
scratch_folder_manager_file_get_children (ScratchFolderManagerFile* self)
{
	GeeCollection* result;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp29_;
	GeeCollection* _tmp30_;
	GError* _inner_error0_ = NULL;
#line 124 "../src/FolderManager/File.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 125 "../src/FolderManager/File.vala"
	if (self->priv->children_valid) {
#line 940 "File.c"
		GeeArrayList* _tmp0_;
		GeeCollection* _tmp1_;
#line 126 "../src/FolderManager/File.vala"
		_tmp0_ = self->priv->_children;
#line 126 "../src/FolderManager/File.vala"
		_tmp1_ = _g_object_ref0 ((GeeCollection*) _tmp0_);
#line 126 "../src/FolderManager/File.vala"
		result = _tmp1_;
#line 126 "../src/FolderManager/File.vala"
		return result;
#line 951 "File.c"
	}
#line 129 "../src/FolderManager/File.vala"
	_tmp2_ = self->priv->_children;
#line 129 "../src/FolderManager/File.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp2_);
#line 957 "File.c"
	{
		GFileEnumerator* enumerator = NULL;
		GFile* _tmp3_;
		GFileEnumerator* _tmp4_;
		GFileInfo* file_info = NULL;
		GFileInfo* _tmp5_;
#line 132 "../src/FolderManager/File.vala"
		_tmp3_ = self->priv->_file;
#line 132 "../src/FolderManager/File.vala"
		_tmp4_ = g_file_enumerate_children (_tmp3_, G_FILE_ATTRIBUTE_STANDARD_NAME, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 132 "../src/FolderManager/File.vala"
		enumerator = _tmp4_;
#line 132 "../src/FolderManager/File.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 972 "File.c"
			goto __catch0_g_error;
		}
#line 137 "../src/FolderManager/File.vala"
		_tmp5_ = g_file_info_new ();
#line 137 "../src/FolderManager/File.vala"
		file_info = _tmp5_;
#line 138 "../src/FolderManager/File.vala"
		while (TRUE) {
#line 981 "File.c"
			GFileInfo* _tmp6_ = NULL;
			GFileEnumerator* _tmp7_;
			GFileInfo* _tmp8_;
			GFileInfo* _tmp9_;
			GFileInfo* _tmp10_;
			GFile* child = NULL;
			GFile* _tmp11_;
			GFileInfo* _tmp12_;
			const gchar* _tmp13_;
			GFile* _tmp14_;
			ScratchFolderManagerFile* child_file = NULL;
			GFile* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			ScratchFolderManagerFile* _tmp18_;
			ScratchFolderManagerFile* _tmp19_;
			gboolean _tmp20_ = FALSE;
			ScratchFolderManagerFile* _tmp21_;
#line 138 "../src/FolderManager/File.vala"
			_tmp7_ = enumerator;
#line 138 "../src/FolderManager/File.vala"
			_tmp8_ = g_file_enumerator_next_file (_tmp7_, NULL, &_inner_error0_);
#line 138 "../src/FolderManager/File.vala"
			_tmp6_ = _tmp8_;
#line 138 "../src/FolderManager/File.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 138 "../src/FolderManager/File.vala"
				_g_object_unref0 (file_info);
#line 138 "../src/FolderManager/File.vala"
				_g_object_unref0 (enumerator);
#line 1012 "File.c"
				goto __catch0_g_error;
			}
#line 138 "../src/FolderManager/File.vala"
			_tmp9_ = _tmp6_;
#line 138 "../src/FolderManager/File.vala"
			_tmp6_ = NULL;
#line 138 "../src/FolderManager/File.vala"
			_g_object_unref0 (file_info);
#line 138 "../src/FolderManager/File.vala"
			file_info = _tmp9_;
#line 138 "../src/FolderManager/File.vala"
			_tmp10_ = file_info;
#line 138 "../src/FolderManager/File.vala"
			if (!(_tmp10_ != NULL)) {
#line 138 "../src/FolderManager/File.vala"
				_g_object_unref0 (_tmp6_);
#line 138 "../src/FolderManager/File.vala"
				break;
#line 1031 "File.c"
			}
#line 139 "../src/FolderManager/File.vala"
			_tmp11_ = self->priv->_file;
#line 139 "../src/FolderManager/File.vala"
			_tmp12_ = file_info;
#line 139 "../src/FolderManager/File.vala"
			_tmp13_ = g_file_info_get_name (_tmp12_);
#line 139 "../src/FolderManager/File.vala"
			_tmp14_ = g_file_get_child (_tmp11_, _tmp13_);
#line 139 "../src/FolderManager/File.vala"
			child = _tmp14_;
#line 140 "../src/FolderManager/File.vala"
			_tmp15_ = child;
#line 140 "../src/FolderManager/File.vala"
			_tmp16_ = g_file_get_path (_tmp15_);
#line 140 "../src/FolderManager/File.vala"
			_tmp17_ = _tmp16_;
#line 140 "../src/FolderManager/File.vala"
			_tmp18_ = scratch_folder_manager_file_new (_tmp17_);
#line 140 "../src/FolderManager/File.vala"
			_tmp19_ = _tmp18_;
#line 140 "../src/FolderManager/File.vala"
			_g_free0 (_tmp17_);
#line 140 "../src/FolderManager/File.vala"
			child_file = _tmp19_;
#line 141 "../src/FolderManager/File.vala"
			_tmp21_ = child_file;
#line 141 "../src/FolderManager/File.vala"
			if (scratch_folder_manager_file_is_valid_directory (_tmp21_, TRUE)) {
#line 141 "../src/FolderManager/File.vala"
				_tmp20_ = TRUE;
#line 1063 "File.c"
			} else {
				ScratchFolderManagerFile* _tmp22_;
				gboolean _tmp23_;
				gboolean _tmp24_;
#line 141 "../src/FolderManager/File.vala"
				_tmp22_ = child_file;
#line 141 "../src/FolderManager/File.vala"
				_tmp23_ = scratch_folder_manager_file_get_is_valid_textfile (_tmp22_);
#line 141 "../src/FolderManager/File.vala"
				_tmp24_ = _tmp23_;
#line 141 "../src/FolderManager/File.vala"
				_tmp20_ = _tmp24_;
#line 1076 "File.c"
			}
#line 141 "../src/FolderManager/File.vala"
			if (_tmp20_) {
#line 1080 "File.c"
				GeeArrayList* _tmp25_;
				ScratchFolderManagerFile* _tmp26_;
#line 142 "../src/FolderManager/File.vala"
				_tmp25_ = self->priv->_children;
#line 142 "../src/FolderManager/File.vala"
				_tmp26_ = child_file;
#line 142 "../src/FolderManager/File.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp25_, _tmp26_);
#line 1089 "File.c"
			}
#line 138 "../src/FolderManager/File.vala"
			_g_object_unref0 (child_file);
#line 138 "../src/FolderManager/File.vala"
			_g_object_unref0 (child);
#line 138 "../src/FolderManager/File.vala"
			_g_object_unref0 (_tmp6_);
#line 1097 "File.c"
		}
#line 146 "../src/FolderManager/File.vala"
		self->priv->children_valid = TRUE;
#line 131 "../src/FolderManager/File.vala"
		_g_object_unref0 (file_info);
#line 131 "../src/FolderManager/File.vala"
		_g_object_unref0 (enumerator);
#line 1105 "File.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp27_;
		const gchar* _tmp28_;
#line 131 "../src/FolderManager/File.vala"
		_error_ = _inner_error0_;
#line 131 "../src/FolderManager/File.vala"
		_inner_error0_ = NULL;
#line 148 "../src/FolderManager/File.vala"
		_tmp27_ = _error_;
#line 148 "../src/FolderManager/File.vala"
		_tmp28_ = _tmp27_->message;
#line 148 "../src/FolderManager/File.vala"
		g_warning ("File.vala:148: %s", _tmp28_);
#line 131 "../src/FolderManager/File.vala"
		_g_error_free0 (_error_);
#line 1125 "File.c"
	}
	__finally0:
#line 131 "../src/FolderManager/File.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 131 "../src/FolderManager/File.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 131 "../src/FolderManager/File.vala"
		g_clear_error (&_inner_error0_);
#line 131 "../src/FolderManager/File.vala"
		return NULL;
#line 1136 "File.c"
	}
#line 151 "../src/FolderManager/File.vala"
	_tmp29_ = self->priv->_children;
#line 151 "../src/FolderManager/File.vala"
	_tmp30_ = _g_object_ref0 ((GeeCollection*) _tmp29_);
#line 151 "../src/FolderManager/File.vala"
	result = _tmp30_;
#line 151 "../src/FolderManager/File.vala"
	return result;
#line 1146 "File.c"
}

static void
scratch_folder_manager_file_class_init (ScratchFolderManagerFileClass * klass,
                                        gpointer klass_data)
{
#line 26 "../src/FolderManager/File.vala"
	scratch_folder_manager_file_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/FolderManager/File.vala"
	g_type_class_adjust_private_offset (klass, &ScratchFolderManagerFile_private_offset);
#line 26 "../src/FolderManager/File.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_scratch_folder_manager_file_get_property;
#line 26 "../src/FolderManager/File.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_scratch_folder_manager_file_set_property;
#line 26 "../src/FolderManager/File.vala"
	G_OBJECT_CLASS (klass)->finalize = scratch_folder_manager_file_finalize;
#line 26 "../src/FolderManager/File.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_FOLDER_MANAGER_FILE_FILE_PROPERTY, scratch_folder_manager_file_properties[SCRATCH_FOLDER_MANAGER_FILE_FILE_PROPERTY] = g_param_spec_object ("file", "file", "file", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/FolderManager/File.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_FOLDER_MANAGER_FILE_PATH_PROPERTY, scratch_folder_manager_file_properties[SCRATCH_FOLDER_MANAGER_FILE_PATH_PROPERTY] = g_param_spec_string ("path", "path", "path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 26 "../src/FolderManager/File.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_FOLDER_MANAGER_FILE_NAME_PROPERTY, scratch_folder_manager_file_properties[SCRATCH_FOLDER_MANAGER_FILE_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/FolderManager/File.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_FOLDER_MANAGER_FILE_ICON_PROPERTY, scratch_folder_manager_file_properties[SCRATCH_FOLDER_MANAGER_FILE_ICON_PROPERTY] = g_param_spec_object ("icon", "icon", "icon", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/FolderManager/File.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_FOLDER_MANAGER_FILE_EXISTS_PROPERTY, scratch_folder_manager_file_properties[SCRATCH_FOLDER_MANAGER_FILE_EXISTS_PROPERTY] = g_param_spec_boolean ("exists", "exists", "exists", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/FolderManager/File.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_FOLDER_MANAGER_FILE_IS_TEMPORARY_PROPERTY, scratch_folder_manager_file_properties[SCRATCH_FOLDER_MANAGER_FILE_IS_TEMPORARY_PROPERTY] = g_param_spec_boolean ("is-temporary", "is-temporary", "is-temporary", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/FolderManager/File.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_FOLDER_MANAGER_FILE_IS_VALID_TEXTFILE_PROPERTY, scratch_folder_manager_file_properties[SCRATCH_FOLDER_MANAGER_FILE_IS_VALID_TEXTFILE_PROPERTY] = g_param_spec_boolean ("is-valid-textfile", "is-valid-textfile", "is-valid-textfile", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/FolderManager/File.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_FOLDER_MANAGER_FILE_IS_EXECUTABLE_PROPERTY, scratch_folder_manager_file_properties[SCRATCH_FOLDER_MANAGER_FILE_IS_EXECUTABLE_PROPERTY] = g_param_spec_boolean ("is-executable", "is-executable", "is-executable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/FolderManager/File.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SCRATCH_FOLDER_MANAGER_FILE_CHILDREN_PROPERTY, scratch_folder_manager_file_properties[SCRATCH_FOLDER_MANAGER_FILE_CHILDREN_PROPERTY] = g_param_spec_object ("children", "children", "children", GEE_TYPE_COLLECTION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1181 "File.c"
}

static void
scratch_folder_manager_file_instance_init (ScratchFolderManagerFile * self,
                                           gpointer klass)
{
	GeeArrayList* _tmp0_;
#line 26 "../src/FolderManager/File.vala"
	self->priv = scratch_folder_manager_file_get_instance_private (self);
#line 63 "../src/FolderManager/File.vala"
	self->priv->_icon = NULL;
#line 121 "../src/FolderManager/File.vala"
	self->priv->children_valid = FALSE;
#line 122 "../src/FolderManager/File.vala"
	_tmp0_ = gee_array_list_new (SCRATCH_FOLDER_MANAGER_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 122 "../src/FolderManager/File.vala"
	self->priv->_children = _tmp0_;
#line 1199 "File.c"
}

static void
scratch_folder_manager_file_finalize (GObject * obj)
{
	ScratchFolderManagerFile * self;
#line 26 "../src/FolderManager/File.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SCRATCH_FOLDER_MANAGER_TYPE_FILE, ScratchFolderManagerFile);
#line 27 "../src/FolderManager/File.vala"
	_g_object_unref0 (self->priv->_file);
#line 28 "../src/FolderManager/File.vala"
	_g_object_unref0 (self->priv->info);
#line 45 "../src/FolderManager/File.vala"
	_g_free0 (self->priv->_name);
#line 63 "../src/FolderManager/File.vala"
	_g_object_unref0 (self->priv->_icon);
#line 122 "../src/FolderManager/File.vala"
	_g_object_unref0 (self->priv->_children);
#line 26 "../src/FolderManager/File.vala"
	G_OBJECT_CLASS (scratch_folder_manager_file_parent_class)->finalize (obj);
#line 1220 "File.c"
}

/**
     * Class for easily dealing with files.
     */
static GType
scratch_folder_manager_file_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ScratchFolderManagerFileClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) scratch_folder_manager_file_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ScratchFolderManagerFile), 0, (GInstanceInitFunc) scratch_folder_manager_file_instance_init, NULL };
	GType scratch_folder_manager_file_type_id;
	scratch_folder_manager_file_type_id = g_type_register_static (G_TYPE_OBJECT, "ScratchFolderManagerFile", &g_define_type_info, 0);
	ScratchFolderManagerFile_private_offset = g_type_add_instance_private (scratch_folder_manager_file_type_id, sizeof (ScratchFolderManagerFilePrivate));
	return scratch_folder_manager_file_type_id;
}

GType
scratch_folder_manager_file_get_type (void)
{
	static volatile gsize scratch_folder_manager_file_type_id__once = 0;
	if (g_once_init_enter (&scratch_folder_manager_file_type_id__once)) {
		GType scratch_folder_manager_file_type_id;
		scratch_folder_manager_file_type_id = scratch_folder_manager_file_get_type_once ();
		g_once_init_leave (&scratch_folder_manager_file_type_id__once, scratch_folder_manager_file_type_id);
	}
	return scratch_folder_manager_file_type_id__once;
}

static void
_vala_scratch_folder_manager_file_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	ScratchFolderManagerFile * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SCRATCH_FOLDER_MANAGER_TYPE_FILE, ScratchFolderManagerFile);
#line 26 "../src/FolderManager/File.vala"
	switch (property_id) {
#line 26 "../src/FolderManager/File.vala"
		case SCRATCH_FOLDER_MANAGER_FILE_FILE_PROPERTY:
#line 26 "../src/FolderManager/File.vala"
		g_value_set_object (value, scratch_folder_manager_file_get_file (self));
#line 26 "../src/FolderManager/File.vala"
		break;
#line 26 "../src/FolderManager/File.vala"
		case SCRATCH_FOLDER_MANAGER_FILE_PATH_PROPERTY:
#line 26 "../src/FolderManager/File.vala"
		g_value_take_string (value, scratch_folder_manager_file_get_path (self));
#line 26 "../src/FolderManager/File.vala"
		break;
#line 26 "../src/FolderManager/File.vala"
		case SCRATCH_FOLDER_MANAGER_FILE_NAME_PROPERTY:
#line 26 "../src/FolderManager/File.vala"
		g_value_set_string (value, scratch_folder_manager_file_get_name (self));
#line 26 "../src/FolderManager/File.vala"
		break;
#line 26 "../src/FolderManager/File.vala"
		case SCRATCH_FOLDER_MANAGER_FILE_ICON_PROPERTY:
#line 26 "../src/FolderManager/File.vala"
		g_value_set_object (value, scratch_folder_manager_file_get_icon (self));
#line 26 "../src/FolderManager/File.vala"
		break;
#line 26 "../src/FolderManager/File.vala"
		case SCRATCH_FOLDER_MANAGER_FILE_EXISTS_PROPERTY:
#line 26 "../src/FolderManager/File.vala"
		g_value_set_boolean (value, scratch_folder_manager_file_get_exists (self));
#line 26 "../src/FolderManager/File.vala"
		break;
#line 26 "../src/FolderManager/File.vala"
		case SCRATCH_FOLDER_MANAGER_FILE_IS_TEMPORARY_PROPERTY:
#line 26 "../src/FolderManager/File.vala"
		g_value_set_boolean (value, scratch_folder_manager_file_get_is_temporary (self));
#line 26 "../src/FolderManager/File.vala"
		break;
#line 26 "../src/FolderManager/File.vala"
		case SCRATCH_FOLDER_MANAGER_FILE_IS_VALID_TEXTFILE_PROPERTY:
#line 26 "../src/FolderManager/File.vala"
		g_value_set_boolean (value, scratch_folder_manager_file_get_is_valid_textfile (self));
#line 26 "../src/FolderManager/File.vala"
		break;
#line 26 "../src/FolderManager/File.vala"
		case SCRATCH_FOLDER_MANAGER_FILE_IS_EXECUTABLE_PROPERTY:
#line 26 "../src/FolderManager/File.vala"
		g_value_set_boolean (value, scratch_folder_manager_file_get_is_executable (self));
#line 26 "../src/FolderManager/File.vala"
		break;
#line 26 "../src/FolderManager/File.vala"
		case SCRATCH_FOLDER_MANAGER_FILE_CHILDREN_PROPERTY:
#line 26 "../src/FolderManager/File.vala"
		g_value_take_object (value, scratch_folder_manager_file_get_children (self));
#line 26 "../src/FolderManager/File.vala"
		break;
#line 1312 "File.c"
		default:
#line 26 "../src/FolderManager/File.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/FolderManager/File.vala"
		break;
#line 1318 "File.c"
	}
}

static void
_vala_scratch_folder_manager_file_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	ScratchFolderManagerFile * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SCRATCH_FOLDER_MANAGER_TYPE_FILE, ScratchFolderManagerFile);
#line 26 "../src/FolderManager/File.vala"
	switch (property_id) {
#line 26 "../src/FolderManager/File.vala"
		case SCRATCH_FOLDER_MANAGER_FILE_FILE_PROPERTY:
#line 26 "../src/FolderManager/File.vala"
		scratch_folder_manager_file_set_file (self, g_value_get_object (value));
#line 26 "../src/FolderManager/File.vala"
		break;
#line 26 "../src/FolderManager/File.vala"
		case SCRATCH_FOLDER_MANAGER_FILE_PATH_PROPERTY:
#line 26 "../src/FolderManager/File.vala"
		scratch_folder_manager_file_set_path (self, g_value_get_string (value));
#line 26 "../src/FolderManager/File.vala"
		break;
#line 1344 "File.c"
		default:
#line 26 "../src/FolderManager/File.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/FolderManager/File.vala"
		break;
#line 1350 "File.c"
	}
}

